Bug 1385441 - Review Request: rpmdeplint - Tool to find errors in RPM packages in the context of their dependency graph
Summary: Review Request: rpmdeplint - Tool to find errors in RPM packages in the conte...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Parag AN(पराग)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-10-17 03:49 UTC by Dan Callaghan
Modified: 2016-11-10 06:19 UTC (History)
4 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-10-31 07:35:43 UTC
panemade: fedora-review+


Attachments (Terms of Use)

Description Dan Callaghan 2016-10-17 03:49:31 UTC
Spec URL: https://fedorapeople.org/~dcallagh/rpmdeplint/rpmdeplint.spec
SRPM URL: https://fedorapeople.org/~dcallagh/rpmdeplint/rpmdeplint-1.2-1.fc26.src.rpm
Description: Rpmdeplint is a tool to find errors in RPM packages in the context of their dependency graph.
Fedora Account System Username: dcallagh

Comment 1 Igor Gnatenko 2016-10-17 06:39:49 UTC
Is there some reason why it's python2 and not py3?

Comment 2 Dan Callaghan 2016-10-17 06:53:26 UTC
To make life easier on RHEL7 (so that we don't have to depend on the whole EPEL7 Python 3 stack).

Internally in our Jenkins we are running rpmdeplint tests on both Python 2 and Python 3 on Fedora, and we consider Python 3 as fully supported, so we could switch this package over to it in future.

Comment 3 Parag AN(पराग) 2016-10-17 08:15:42 UTC
Yeah I was just checking spec for py3 compatibility before posting any review. I see setup.py says its compatible with py3.

Comment 4 Dan Callaghan 2016-10-18 00:13:13 UTC
Yeah, so are you saying for the Fedora package you would prefer it is built against and runs in python3 instead of python2? I would leave it as python2 for EPEL.

Comment 5 Dan Callaghan 2016-10-18 01:13:40 UTC
On second thought, rpmdeplint is also exposing a Python API so I guess for completeness I should really make this package python-rpmdeplint which produces python2-rpmdeplint and python3-rpmdeplint. On Fedora the /usr/bin/rpmdeplint could be the Python 3 version.

Comment 6 Parag AN(पराग) 2016-10-18 02:02:57 UTC
you are right. Sorry was busy yesterday and Internet was down. Its just up. here is what I propose this package spec https://pnemade.fedorapeople.org/fedora-work/rpmdeplint.spec

Also, was trying to make this compatible with EPEL7 but I saw there do not exist python2-<pkgs> names for some packages.

Can you please submit an update?

Comment 7 Dan Callaghan 2016-10-20 01:45:40 UTC
Oh I see, so rpmdeplint package provides the CLI, and python2-rpmdeplint and python3-rpmdeplint provide the Python API? Makes sense. I will post a new version.

Comment 8 Dan Callaghan 2016-10-20 05:20:30 UTC
I just remembered why this is never going to run in Python 3 on EPEL7: it requires rpm Python 3 bindings, which don't exist in EPEL7 because the rpm package comes from RHEL.

Comment 9 Dan Callaghan 2016-10-20 06:02:17 UTC
Spec URL: https://fedorapeople.org/~dcallagh/rpmdeplint/rpmdeplint.spec
SRPM URL: https://fedorapeople.org/~dcallagh/rpmdeplint/rpmdeplint-1.2-2.fc26.src.rpm

With this version, the Fedora package produces:

* rpmdeplint
* python2-rpmdeplint
* python3-rpmdeplint

with /usr/bin/rpmdeplint in the base package running in Python 3. On EPEL7 it produces:

* rpmdeplint
* python2-rpmdeplint

with /usr/bin/rpmdeplint running in Python 2 instead.

Comment 10 Parag AN(पराग) 2016-10-20 08:46:49 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Suggestion:
1) add trailing '/' in %files that is change
%{pythonX_sitelib}/%{name}
to
%{pythonX_sitelib}/%{name}/

This will also help to understand its directory not file being packaged.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v2 or later)", "Unknown or generated". 15
     files have unknown license. Detailed output of licensecheck in
     /home/parag/1385441-rpmdeplint/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-rpmdeplint , python3-rpmdeplint
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rpmdeplint-1.2-2.fc26.noarch.rpm
          python2-rpmdeplint-1.2-2.fc26.noarch.rpm
          python3-rpmdeplint-1.2-2.fc26.noarch.rpm
          rpmdeplint-1.2-2.fc26.src.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
3 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
python3-rpmdeplint (rpmlib, GLIBC filtered):
    python(abi)
    python3-hawkey
    python3-librepo
    python3-six
    rpm-python3

python2-rpmdeplint (rpmlib, GLIBC filtered):
    python(abi)
    python-hawkey
    python-librepo
    python-six
    rpm-python

rpmdeplint (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python3-rpmdeplint



Provides
--------
python3-rpmdeplint:
    python3-rpmdeplint
    python3.5dist(rpmdeplint)
    python3dist(rpmdeplint)

python2-rpmdeplint:
    python-rpmdeplint
    python2-rpmdeplint
    python2.7dist(rpmdeplint)
    python2dist(rpmdeplint)

rpmdeplint:
    rpmdeplint



Source checksums
----------------
https://files.pythonhosted.org/packages/source/r/rpmdeplint/rpmdeplint-1.2.tar.gz :
  CHECKSUM(SHA256) this package     : ccb0c93d2a7e36171058b16038c9806d2cecaaa6b614df743447d4a6d2122709
  CHECKSUM(SHA256) upstream package : ccb0c93d2a7e36171058b16038c9806d2cecaaa6b614df743447d4a6d2122709


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1385441 -m fedora-rawhide-x86_64

APPROVED.

Comment 11 Dan Callaghan 2016-10-20 23:35:39 UTC
Thanks for the review!

(In reply to Parag AN(पराग) from comment #10)
> Suggestion:
> 1) add trailing '/' in %files that is change
> %{pythonX_sitelib}/%{name}
> to
> %{pythonX_sitelib}/%{name}/
> 
> This will also help to understand its directory not file being packaged.

Good idea, I never thought of that before. Will make the change before importing.

Comment 12 Gwyn Ciesla 2016-10-21 13:27:16 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/rpmdeplint

Comment 13 Fedora Update System 2016-10-25 01:22:33 UTC
rpmdeplint-1.2-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-81618719a7

Comment 14 Fedora Update System 2016-10-25 02:22:21 UTC
rpmdeplint-1.2-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-a5cb5e478f

Comment 15 Fedora Update System 2016-10-25 04:22:15 UTC
rpmdeplint-1.2-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-55222bf542

Comment 16 Fedora Update System 2016-10-25 06:17:55 UTC
rpmdeplint-1.2-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-0faa9b99da

Comment 17 Fedora Update System 2016-10-31 07:35:43 UTC
rpmdeplint-1.2-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2016-11-01 13:21:50 UTC
rpmdeplint-1.2-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2016-11-01 16:23:15 UTC
rpmdeplint-1.2-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2016-11-10 06:19:33 UTC
rpmdeplint-1.2-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.